# Recyclarr

[![GitHub License](https://img.shields.io/github/license/recyclarr/recyclarr)](https://github.com/recyclarr/recyclarr/blob/master/LICENSE)
[![Build Workflow Status](https://img.shields.io/github/actions/workflow/status/recyclarr/recyclarr/build.yml?branch=master&logo=githubactions)](https://github.com/recyclarr/recyclarr/actions/workflows/build.yml?query=branch%3Amaster)
[![Sonar Quality Gate](https://img.shields.io/sonar/quality_gate/recyclarr_recyclarr?server=https%3A%2F%2Fsonarcloud.io&logo=sonarcloud)](https://sonarcloud.io/summary/new_code?id=recyclarr_recyclarr)
[![GitHub Release](https://img.shields.io/github/v/release/recyclarr/recyclarr?logo=github)](https://github.com/recyclarr/recyclarr/releases/)
[![Discord](https://img.shields.io/discord/492590071455940612?label=TRaSH-Guides&logo=discord)](https://discord.com/invite/Vau8dZ3)

A command-line application that will automatically synchronize recommended settings from the [TRaSH
guides](https://trash-guides.info/) to your Sonarr/Radarr instances.

## Features

Recyclarr supports Radarr and Sonarr (v4 and higher only). The following information can be synced
to these services from the TRaSH Guides. For a more detailed features list, see the [Features] page.

[Features]: https://recyclarr.dev/wiki/features/

- Quality Profiles, including qualities and quality groups
- Custom Formats, including scores (from guide or manual)
- Quality Definitions (file sizes)
- Media Naming Formats

## Read the Documentation

[![view - Documentation](https://img.shields.io/badge/view-Documentation-blue?style=for-the-badge)](https://recyclarr.dev/)

Main documentation is located in [the wiki](https://recyclarr.dev/wiki). Links provided below for
some main topics.

- [Installation](https://recyclarr.dev/wiki/installation/)
- [Command Line Reference](https://recyclarr.dev/wiki/cli/)
- [Configuration Reference](https://recyclarr.dev/wiki/yaml/config-reference/)
- [Settings Reference](https://recyclarr.dev/wiki/yaml/settings-reference/)
- [Troubleshooting](https://recyclarr.dev/wiki/troubleshooting/help/)
- [Upgrade Guides](https://recyclarr.dev/wiki/upgrade-guide/)
